/* snakey.c */
/*
    [==============================================================]
    [ Snakey                                                       ]
    [ Copyright (c) 2000 by Mihnea-Costin Grigore <mgc8@iname.com> ]
    [==============================================================]

    [== Main program ==]


    This program is free software; you can rdistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License F more details.

    You should have received a copy of the GNU General Public License
    along with this program; A not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "allegro.h"

/* 
    Sorry about the readability, I had to do this in order to comply with
    the 10k limit... If you want the original source, just send me an
    e-mail and I'll be glad to send it to you.
*/

#define I int
#define A if
#define B else
#define C case
#define D break
#define F for
#define S struct
#define N NULL
#define O SCREEN_W
#define P SCREEN_H
#define U p[0]
#define E p[1]
#define V void
#define X p[i]
#define Y f[i][j]
#define tpf textprintf

S tail_node {
  I x, y;                 /* position on the table */
  S tail_node *n;
};

typedef S {
  I hx, hy;               /* head x, head y */
  I hum;	          /* TRUE if player is human, 
                             FALSE if it is computer-controlled */
  I dir;                  /* current direction */
  I scr;                  /* current score */
  I liv;                  /* number of lives left */
  I ntg;                  /* Needs To Grow */
  volatile I inv;         /* invulnerability */
  I died;                 /* self explanatory */
  S tail_node *tail;      /* linked list of tail segments */
  S tail_node *bfl;       /* the segment beFe the last one */
} player_type;

typedef S {
  I t;                    /* type of the object on that spot */
  I m;                    /* if the tile has been modified */
} tile_type;


I dx[4] = {0, 0, -1, 1};
I dy[4] = {-1, 1, 0, 0};

BITMAP *g[2][4][4],         /* holds the head and segment sprites
                               for each of the two players */
       *g_wall, *g_f1,   
       *g_f2, *g_f3,        /* "wall" and "food" sprites */
       *g_f4, *g_f5;  
player_type p[2];           /* player info */
tile_type f[64][48];        /* playing field */
I R, Q;                     /* maximum number of tiles, depending
                               on resolution */

I el, eg, screen_modified;    /* flags for game events */

I lv,                         /* current level */
    sp,                       /* speed */
    npl,                      /* number of players */
    nf,                       /* number of "food" items */
    diff,                     /* difficulty */
    p1_comp,                  /* player one is computer */
    p2_comp;                  /* player two is computer */
					      
I bl, rd, gr, wh;             /* some basic colours */
volatile I spd;               /* speed counter */

V spm()
{
  spd++;
  A (U.inv > 0) U.inv--;
  A (E.inv > 0) E.inv--;
}
END_OF_FUNCTION(spm);


S tail_node *new_tail()
{
  return ((S tail_node *)malloc(sizeof(S tail_node)));
}


I is_f(I x, I y)
{
  return ((f[x][y].t >= 2) && (f[x][y].t <= 6));
}


BITMAP *cb()
{
  BITMAP *b;
  b = create_bitmap(16, 16); clear(b);
  return b;
}


V update_snakes()
{
  I i, nhx, nhy, oscr;
  S tail_node *nd, *tmp;
  
  F (i=0; i<npl; i++) {
    nhx = X.hx + dx[X.dir];
    nhy = X.hy + dy[X.dir];
    A ((f[nhx][nhy].t != 0) && (!is_f(nhx, nhy))) {
      A (!X.inv) X.died = -1;
    }
    B {
      A (is_f(nhx, nhy)) { 
        oscr = X.scr;
        switch (f[nhx][nhy].t) {
	  C 2 : X.scr += sp * 10;
	               X.ntg += 2;
	               nf--;
		       D;
          C 3 : X.scr += 2 * (sp * 10);
	               X.ntg += 3;
	               nf--;
		       D;
          C 4 : X.scr += 3 * (sp * 10);
	               X.ntg += 4;
	               nf--;
		       D;
          C 5 : X.scr += 4 * (sp * 10);
	               X.inv = 1000;
		       D;
          C 6 : X.scr -= 5 * (sp * 10);
	               A ((X.scr) < 0) X.scr = 0;
	               el = -1;
		       D;
        }
        A ((I)(X.scr / 1000) > (I)(oscr / 1000)) X.liv++;
        A (nf < 1) el = -1;
      }
      nd = new_tail();
      (*nd).x = X.hx;
      (*nd).y = X.hy;
      (*nd).n = X.tail;
      A (X.tail) f[X.hx][X.hy].t = (i+1)*10+2;
      B f[X.hx][X.hy].t = (i+1)*10+1;
      f[X.hx][X.hy].m = -1;
      X.hx = nhx;
      X.hy = nhy;
      f[nhx][nhy].t = (i+1)*10+0;
      f[nhx][nhy].m = -1;
      X.tail = nd;
      A (X.ntg > 0) 
        X.ntg--;
      B {
        tmp = X.tail;
        while ((*tmp).n) {
          nd = tmp;
          tmp = (*tmp).n;
        }
        A (((*(*nd).n).x == 0) || ((*(*nd).n).x == R-1) ||
            ((*(*nd).n).y == 0) || ((*(*nd).n).y == Q-1))
	  f[(*(*nd).n).x][(*(*nd).n).y].t = 1;
	B
	  f[(*(*nd).n).x][(*(*nd).n).y].t = 0;
        f[(*(*nd).n).x][(*(*nd).n).y].m = -1; 
        free((*nd).n);
	(*nd).n = N;
	f[(*nd).x][(*nd).y].t = (i+1)*10+1;
	f[(*nd).x][(*nd).y].m = -1;
        tmp = X.tail;
	nd = N;
        while ((*tmp).n) {
          nd = tmp;
          tmp = (*tmp).n;
        }
	X.bfl = nd;
      }
    }
  }      
  screen_modified = -1;
}


V draw_mdf(BITMAP *bmp)
{
  I i, j, x, y, x1, y1, x2, y2, pl, py, pcol, dir, t;
  char *txt = malloc(100);
  
  /* Draw the playing field */
  F (i=0; i<R; i++)
    F (j=0; j<Q; j++)
      A (Y.m) {
        x = i*16;
        y = j*16;
        switch (Y.t) {
          C 0 : rectfill(bmp, x, y, x+15, y+15, bl);
  	               D;
  	  C 1  : blit(g_wall, bmp, 0, 0, x, y, 16, 16);
  	               D;
  	  C 2 : draw_sprite(bmp, g_f1, x, y);
	               D;
  	  C 3 : draw_sprite(bmp, g_f2, x, y);
	               D;
  	  C 4 : draw_sprite(bmp, g_f3, x, y);
	               D;
  	  C 5 : draw_sprite(bmp, g_f4, x, y);
	               D;
  	  C 6 : draw_sprite(bmp, g_f5, x, y);
	               D;
          C 10    : 
	  C 20    : pl = (I)(Y.t/10 - 1);
	               blit(g[pl][0][p[pl].dir], bmp, 0, 0, x, y, 16, 16);
	               D;
	  C 11    :
	  C 21    : pl = (I)(Y.t/10 - 1);
	               A (p[pl].bfl) {
	                 x1 = (*p[pl].bfl).x;
	                 y1 = (*p[pl].bfl).y;
		       }
		       B {
	                 x1 = p[pl].hx;
	                 y1 = p[pl].hy;
		       }
		       A (i==x1) {
		         A (j>y1) dir = 0;
			 B dir = 1;
		       }
		       B {
		         A (i>x1) dir = 2;
			 B dir = 3;
		       }
	               draw_sprite(bmp, g[pl][1][dir], x, y);
	               D;
	  C 12    :
	  C 22    : pl = (I)(Y.t/10 - 1);
	               x1 = p[pl].hx;
	               y1 = p[pl].hy;
		       x2 = (*(*p[pl].tail).n).x;
		       y2 = (*(*p[pl].tail).n).y;
		       A (x1 == x2) {
		         t = 3;
			 A (j>y1) dir = 0;
			 B dir = 1;
		       }
		       B A (y1 == y2) {
		         t = 3;
			 A (i>x1) dir = 2;
			 B dir = 3;
		       }
		       B {
		         t = 2;
			 A (((x1 == i) && (y1 < j) && (x2 > i) && (y2 == j)) ||
			     ((x2 == i) && (y2 < j) && (x1 > i) && (y1 == j)))
			     dir = 0;
			 B A (((x1 == i) && (y1 > j) && (x2 > i) && (y2 == j)) ||
			          ((x2 == i) && (y2 > j) && (x1 > i) && (y1 == j)))
			          dir = 1;
			 B A (((x1 < i) && (y1 == j) && (x2 == i) && (y2 > j)) ||
			          ((x2 < i) && (y2 == j) && (x1 == i) && (y1 > j)))
			          dir = 2;
			 B dir = 3;
		       }
	               draw_sprite(bmp, g[pl][t][dir], x, y);
	               D;
        }
	Y.m = 0;
      }

  /* Show info */
  rect(bmp, 0, 0, O-1, P-1, wh);
  hline(bmp, 0, Q*16 - 1, R*16 - 1, wh);
  F (i=0; i<npl; i++) {
    txt[0]=0;
    A (X.hum) strcat(txt, "   Human %d -> ");
    B strcat(txt, "Computer %d -> ");
    strcat(txt, "Lives: %d   Score: %d  ");
    A (i==0) {
      py = Q*16 + 5;
      pcol = gr;
    }
    B {
      py = P - 15;
      pcol = rd;
    }
    tpf(bmp, font, 20, py, pcol, txt, i+1, X.liv, X.scr);
    A (X.inv) tpf(bmp, font, 60+text_length(font, txt), py, makecol(255, 255, 0), "Invulnerable: %d    ", X.inv);
    B tpf(bmp, font, 60+text_length(font, txt), py, pcol, "                       ");
  }
  tpf(bmp, font, O - 80, Q*16 + 5, wh, "Level: %d", lv);
  tpf(bmp, font, O - 80, P - 15, wh, "Speed: %d", sp);
}


V init_pl(I i, I human, I lives, I score)
{
  X.hx = (I)(R / 2);
  A (i==0) {
    X.hy = Q - 1;
    X.dir = 0;
  }
  B {
    X.hy = 0;
    X.dir = 1;
  }
  X.hum = human;
  X.liv = lives;
  X.scr = score;
  X.ntg = 5;
  X.inv = 0;
  X.died = 0;
  X.tail = N;
  X.bfl = N;
}


V clear_pl(I i)
{
  S tail_node *tmp1, *tmp2;
  
  f[X.hx][X.hy].t = 0;
  f[X.hx][X.hy].m = -1;
  tmp1 = X.tail;
  tmp2 = N;
  while (tmp1) {
    A (tmp2) free(tmp2);
    tmp2 = tmp1;
    f[(*tmp1).x][(*tmp1).y].t = 0;
    f[(*tmp1).x][(*tmp1).y].m = -1;
    tmp1 = (*tmp1).n;
  }
  free(tmp2);
  X.tail = N;
}


V rnd_lv(I diff)
{
  I i, j;
  
  F (i=0; i<R-1; i++)
    F (j=0; j<Q-1; j++)
      A ((i != (I)(R / 2)) && (Y.t == 0))
        A ((rand() % 1000) < 5*diff) {
          Y.t = 1;
	  Y.m = -1;
        }
}


V rnd_f()
{
  I i, j, r, p1 = 0;
  
  F (i=0; i<R-1; i++)
    F (j=0; j<Q-1; j++)
      A (Y.t == 0) {
        r = rand() % 1000;
        A (r < 15) {
          A (r < 10) Y.t = 2;
          B A (r < 14) Y.t = 3;
          B A (r == 14) Y.t = 4;
          nf++;
          Y.m = -1;
        }
        B A (r == 16) {
          A (!p1) {
            Y.t = 5;
            Y.m = -1;
            p1 = -1;
          }
        }
        B A (r == 17) {
          A (!p1) {
            Y.t = 6;
            Y.m = -1;
            p1 = -1;
          }
	}
      }
}


V ai_move(I i)
{
  I x, y, j, t, pd[4] = {1, 1, 1, 1}, max1, max2, idir;
  
  x = X.hx;
  y = X.hy;

  A (i == 1) {
    t = f[U.hx + dx[U.dir]][U.hy + dy[U.dir]].t;
    f[U.hx + dx[U.dir]][U.hy + dy[U.dir]].t = 10;
  }
  A (y>1) pd[0] = f[x][y-1].t;
  A (y<Q-1) pd[1] = f[x][y+1].t;
  pd[2] = f[x-1][y].t;
  pd[3] = f[x+1][y].t;
  
  idir = X.dir;
  max1 = -100;
  max2 = -100;
  F (j=0; j<4; j++)
    A ((pd[j] == 0) || ((pd[j] >= 2) && (pd[j] <= 6)))
      A (pd[j] > max1)
        max1 = pd[j];
  F (j=0; j<4; j++)
    A (pd[j] == max1) {
      A (idir == j) pd[j] += (rand() % 575);
      B pd[j] += (rand() % 100);
      A (pd[j] > max2) {
        max2 = pd[j];
	X.dir = j;
      }
    }
  A (i == 1) f[U.hx + dx[U.dir]][U.hy + dy[U.dir]].t = t;
}


V new_lv()
{
  I i, j;
  
  /* Initialize game variables */
  init_pl(0, U.hum, U.liv, U.scr);
  init_pl(1, E.hum, E.liv, E.scr);
  lv++;
  el = 0;
  screen_modified = 0;
  nf = 0;
  srand(time(N));

  /* Initialize game table */
  F (i=0; i<R; i++)
    F (j=0; j<Q; j++) {
      A ((i==0) || (j==0) || (i==R-1) || (j==Q-1)) 
        Y.t = 1;
      B 
        Y.t = 0;
      Y.m = -1;
    }
  
  /* Draw a random level */
  rnd_lv(diff);
  rnd_f();
  draw_mdf(screen);
}


V close_lv()
{
  clear(screen);
  clear_pl(0);
  clear_pl(1);
}


V ending()
{
  I x1, y1, x2, y2; 
 
  draw_mdf(screen);
  F (y1 = 0; y1<Q*16; y1++)
    F (x1 = 0; x1<O; x1++)
      A (getpixel(screen, x1, y1) && (getpixel(screen, x1, y1) != 16)) putpixel(screen, x1, y1, makecol(0, 200, 0));

  x1 = (I)(O / 2 - 60);
  y1 = (I)(P / 2 - 40);
  x2 = (I)(O / 2 + 60);
  y2 = (I)(P / 2 - 10);
  rectfill(screen, x1-10, y1-10, x2+10, y2+10, bl);
  rect(screen, x1, y1, x2, y2, gr);
  rect(screen, x1+1, y1+1, x2-1, y2-1, gr);
  textout(screen, font, "SYSTEM ERROR", x1+13, y1+12, gr);
  clear_keybuf();
  readkey();
  rest(500);
}


V init_spr(I i)
{
  draw_sprite_v_flip(g[i][0][1], g[i][0][0], 0, 0);
  rotate_sprite(g[i][0][2], g[i][0][0], 0, -1, 192<<16);
  draw_sprite_h_flip(g[i][0][3], g[i][0][2], 0, 0);

  draw_sprite_v_flip(g[i][1][1], g[i][1][0], 0, 0);
  rotate_sprite(g[i][1][2], g[i][1][0], 0, -1, 192<<16);
  draw_sprite_h_flip(g[i][1][3], g[i][1][2], 0, 0);

  draw_sprite_v_flip(g[i][3][1], g[i][3][0], 0, 0);
  rotate_sprite(g[i][3][2], g[i][3][0], 0, -1, 192<<16);
  draw_sprite_h_flip(g[i][3][3], g[i][3][2], 0, 0);
  
  draw_sprite_v_flip(g[i][2][1], g[i][2][0], 0, 0);
  draw_sprite_h_flip(g[i][2][2], g[i][2][1], 0, 0);
  draw_sprite_v_flip(g[i][2][3], g[i][2][2], 0, 0);
}


V init_gfx(I bpp, I gfx, I res)
{
  I i, j, k;
  BITMAP *bmp;
  DATAFILE *df;

  /* Initialize Allegro */
  allegro_init();
  install_keyboard();
  install_timer();
  set_color_depth(bpp);
  switch (res) {
    C 1  : set_gfx_mode(gfx, 640, 480, 0, 0);
              D;
    C 2  : set_gfx_mode(gfx, 800, 600, 0, 0);
              D;
    C 3  : set_gfx_mode(gfx, 1024, 768, 0, 0);
              D;
    default : set_gfx_mode(gfx, 800, 600, 0, 0);
              D;
  }
  
  /* Set up some basic colours */
  bl = makecol(0, 0, 0);
  rd   = makecol(255, 0, 0);
  gr = makecol(0, 255, 0);
  wh = makecol(255, 255, 255);

  /* Set table limits */
  R = (I)(O / 16);
  Q = (I)(P / 16 - 2);
  
  /* Load and prepare sprites */
  F (i=0; i<=1; i++)
    F (j=0; j<=3; j++)
      F (k=0; k<=3; k++)
        g[i][j][k] = cb();
  g_wall = cb();
  g_f1 = cb();
  g_f2 = cb();
  g_f3 = cb();
  g_f4 = cb();
  g_f5 = cb();

  df = load_datafile("gfx.dat");
  bmp = df[0].dat;
  
  blit(bmp, g[0][0][0], 0, 0, 0, 0, 16, 16);
  blit(bmp, g[0][3][0], 16, 0, 0, 0, 16, 16);
  blit(bmp, g[0][2][0], 32, 0, 0, 0, 16, 16);
  blit(bmp, g[0][1][0], 48, 0, 0, 0, 16, 16);

  blit(bmp, g[1][0][0], 64, 0, 0, 0, 16, 16);
  blit(bmp, g[1][3][0], 80, 0, 0, 0, 16, 16);
  blit(bmp, g[1][2][0], 96, 0, 0, 0, 16, 16);
  blit(bmp, g[1][1][0], 112, 0, 0, 0, 16, 16);

  blit(bmp, g_f1, 128, 0, 0, 0, 16, 16);
  blit(bmp, g_f2, 144, 0, 0, 0, 16, 16);
  blit(bmp, g_f3, 160, 0, 0, 0, 16, 16);
  blit(bmp, g_f4, 176, 0, 0, 0, 16, 16);
  blit(bmp, g_f5, 192, 0, 0, 0, 16, 16);
  blit(bmp, g_wall, 208, 0, 0, 0, 16, 16);
  
  unload_datafile(df);

  init_spr(0);
  init_spr(1);
}


V init_game()
{
  /* Set the timer */
  LOCK_VARIABLE(spd);
  LOCK_DATA(p, 2*sizeof(player_type));
  LOCK_FUNCTION(spm);
  spd = 0;
  install_int(spm, 20);
  eg = 0;
  
  /* Set a lv */
  lv = 0;
  init_pl(0, !p1_comp, 3, 0);
  init_pl(1, !p2_comp, 3, 0);
  new_lv();
}


V run_game()
{
  I i, k, dc1, dc2;
  
  dc1 = 0;
  dc2 = 0;
  while (!eg) {
    A (keypressed()) {
      k = readkey();
      switch (k >> 8) {
        C KEY_UP    : A ((U.hum) && (U.dir != 1) && (!dc1)) 
	                   U.dir = 0;
			 dc1 = -1;  
	                 D;
	C KEY_DOWN  : A ((U.hum) && (U.dir != 0) && (!dc1))
	                   U.dir = 1;
			 dc1 = -1;  
	                 D;
	C KEY_LEFT  : A ((U.hum) && (U.dir != 3) && (!dc1))
	                   U.dir = 2;
			 dc1 = -1;  
	                 D;
	C KEY_RIGHT : A ((U.hum) && (U.dir != 2) && (!dc1))
	                   U.dir = 3;
			 dc1 = -1;  
	                 D; 
        C KEY_E     : A ((E.hum) && (E.dir != 1) && (!dc2))
	                   E.dir = 0;
			 dc2 = -1;  
	                 D;
	C KEY_D     : A ((E.hum) && (E.dir != 0) && (!dc2))
	                   E.dir = 1;
			 dc2 = -1;  
	                 D;
	C KEY_S     : A ((E.hum) && (E.dir != 3) && (!dc2)) 
	                   E.dir = 2;
			 dc2 = -1;  
	                 D;
	C KEY_F     : A ((E.hum) && (E.dir != 2) && (!dc2))
	                   E.dir = 3;
			 dc2 = -1;  
	                 D; 
        C KEY_P     : remove_int(spm);
	                 while (!keypressed());
			 k = readkey();
			 install_int(spm, 20);
			 D;
	C KEY_ESC   : eg = -1;
	                 D;
      }
    }
    A (spd >= (10 - sp)) {
      A (!U.hum) ai_move(0);
      A (npl > 1) A (!E.hum) ai_move(1);
      update_snakes();
      F (i=0; (i<npl) && (!eg); i++)
        A (X.died) {
          X.liv--;
	  X.scr -= sp * 50;
	  A (X.scr < 0) X.scr = 0;
          A (X.liv <= 0) {
	    ending();
	    eg = -1;
	  }
	  B {
	    clear_pl(i);
	    init_pl(i, X.hum, X.liv, X.scr);
	  }
	}
      spd = 0;
      dc1 = 0;
      dc2 = 0;
    }
    A (el) {
      close_lv();
      A ((!((lv+1) % 5)) && (sp < 10)) sp++;
      A (!((lv+1) % 2)) diff++;
      new_lv();
    }
    A ((screen_modified) && (!eg)) {
      draw_mdf(screen);
      screen_modified = 0;
    }
  }
}


V close_game()
{
  I i, j, k;
  S tail_node *tmp1, *tmp2;
  
  remove_int(spm);
  F (i=0; i<=1; i++)
    F (j=0; j<=2; j++)
      F (k=0; k<=3; k++)
        destroy_bitmap(g[i][j][k]);

  destroy_bitmap(g_f1);
  destroy_bitmap(g_f2);
  destroy_bitmap(g_f3);
  destroy_bitmap(g_f4);
  destroy_bitmap(g_f5);
  destroy_bitmap(g_wall);
	
  F (i=0; i<2; i++) {
    tmp1 = X.tail;
    tmp2 = N;
    while (tmp1) {
      A (tmp2) free(tmp2);
      tmp2 = tmp1;
      tmp1 = (*tmp1).n;
    }
    free(tmp2);
    X.tail = N;
  }
}


I main(I argc, char *argv[])
{
  I bpp, gfx, res;
  char opt;
  
  bpp = 16;
  gfx = GFX_AUTODETECT;
  res = 2;
  sp = 2;
  diff = 1;
  npl = 1;
  p1_comp = 0;
  p2_comp = 0;

  /* Check F command-line options */
  while ((opt = getopt(argc, argv, "b:g:r:d:s:p:c:")) != -1) {
    switch (opt) {
      C 'b': bpp = strtol(optarg, N, 0);
                D;
      C 'g': gfx = strtol(optarg, N, 0);
                D;
      C 'r': res = strtol(optarg, N, 0);
                D;
      C 'd': diff = strtol(optarg, N, 0);
                A (diff<0) diff = 0;
		if (diff>20) diff = 20;
                D;     
      C 's': sp = strtol(optarg, N, 0);
                A (sp<1) sp = 1;
		if (sp>10) sp = 10;
                D;     
      C 'p': npl = strtol(optarg, N, 0);
                A (npl<1) npl = 1;
		if (npl>2) npl = 2;
                D;
      C 'c': A (strtol(optarg, N, 0) == 1) p1_comp = -1;
                B A (strtol(optarg, N, 0) == 2) p2_comp = -1;
		B A (strtol(optarg, N, 0) == 3) {
		  p1_comp = -1;
		  p2_comp = -1;
		}
		D;
    }
  }

  /* Initialize graphics */
  init_gfx(bpp, gfx, res);
  
  /* Initialize game */
  init_game();
  
  /* Main loop */
  run_game();
    
  /* The End */
  close_game();
  return 0;
}

END_OF_MAIN()
